#!/usr/bin/env node

/*!
 * gulpis
 *
 * Copyright (c) 2016 Katsunori Koyanagi.
 * Licensed under the MIT license.
 */

"use strict";

//gulpがなければインストール
var loader = require("../lib/loader");
var util = require("../lib/util");

loader.loadModule("gulp");
loader.loadModule("gulp-util");

//gulpをコマンドで呼び出し
var child_process = require("child_process");
var path = require("path");
var args = process.argv.slice(2);
var fs = require("fs");

//gulpfile.jsのある場所をプロジェクトルートとして取得
var base = process.argv[1];
while (true) {
	try {
		fs.statSync(path.join(base, "gulpfile.js"));
		break;
	} catch (e) {
		var b = path.dirname(base);
		if(base == b){
			break;
		}
		base = b;
	}
}
var cmd = path.join(base, "node_modules", ".bin", util.cmd("gulp"));

args.push("--internal--rerun--mode=true");

//ループ実行
while (true) {
	let result = child_process.spawnSync(cmd, args, { stdio: "inherit" });
	if (!(result.status in util.envNames)) {
		break;
	}

	let name = util.envNames[result.status];
	if (name) {
		process.env.NODE_ENV = name;
	}
}
